SystemOrganization addCategory: #'SWE-IssueTracker'!

Object subclass: #ITImageDB
	instanceVariableNames: ''
	classVariableNames: 'ISSUES NEXTID'
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITImageDB class methodsFor: 'as yet unclassified' stamp: 'afk 11/12/2007 16:11'!
connect

	^ self new.! !

!ITImageDB methodsFor: 'Issues' stamp: 'afk 11/12/2007 16:27'!
addIssue: anIssue

	anIssue id: NEXTID.
	ISSUES at: anIssue id put: anIssue.
	NEXTID := NEXTID+1.
	
	^ anIssue! !

!ITImageDB methodsFor: 'as yet unclassified' stamp: 'afk 11/12/2007 16:25'!
initialize

	ISSUES ifNil: [ISSUES := Dictionary new].
	NEXTID ifNil: [NEXTID := 0].
	super initialize.! !

Object subclass: #ITIssue
	instanceVariableNames: 'id tags comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssue methodsFor: 'changing' stamp: 'afk 11/12/2007 16:04'!
addComment: aComment
	
	comments add: aComment.! !

!ITIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 16:20'!
id
	^ id! !

!ITIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 16:20'!
id: anObject
	id := anObject! !

!ITIssue methodsFor: 'as yet unclassified' stamp: 'afk 11/12/2007 16:22'!
initialize
	
	tags := Dictionary new.
	comments := OrderedCollection new.
	super initialize.! !

!ITIssue methodsFor: 'as yet unclassified' stamp: 'afk 11/12/2007 16:01'!
setTag: aTag to: aValue
	
	tags at: aTag put: aValue. ! !

Object subclass: #ITIssueManager
	instanceVariableNames: 'database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssueManager methodsFor: 'as yet unclassified' stamp: 'afk 11/12/2007 16:33'!
addIssueWithTitle: aTitle

	| anIssue |
	
	anIssue := ITIssue new.
	anIssue setTag: 'title' to: aTitle.
			
	^ database addIssue: anIssue. ! !

!ITIssueManager methodsFor: 'as yet unclassified' stamp: 'afk 11/12/2007 16:30'!
addIssueWithTitle: aTitle withComment: aComment

	| anIssue |
	
	anIssue := ITIssue new.
	anIssue setTag: 'title' to: aTitle;
			addComment: aComment.
			
	^ database addIssue: anIssue. ! !

!ITIssueManager methodsFor: 'as yet unclassified' stamp: 'afk 11/12/2007 16:22'!
initialize
	
	database := ITImageDB connect.
	super initialize.! !

WAComponent subclass: #ITAddIssueComponent
	instanceVariableNames: 'title initialComment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITAddIssueComponent class methodsFor: 'as yet unclassified' stamp: 'afk 11/12/2007 11:42'!
canBeRoot
	^ true! !

!ITAddIssueComponent methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
initialComment
	^ initialComment! !

!ITAddIssueComponent methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
initialComment: anObject
	initialComment := anObject! !

!ITAddIssueComponent methodsFor: 'as yet unclassified' stamp: 'afk 11/12/2007 15:54'!
renderContentOn: html
	html heading 
		level: 1;
		with: 'Add Issue'.
	html form: 
		[
		html text: 'Titel'.
			html break.
		html textInput on: #title of: self.
			html break.
		html text: 'Description'.
			html break.
		html textArea on: #initialComment of: self.
			html break.
		html submitButton 
			callback: [ITIssueManager new addIssueWithTitle: self title withComment: self initialComment ];
			value: 'add Issue'.
		]! !

!ITAddIssueComponent methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
title
	^ title! !

!ITAddIssueComponent methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
title: anObject
	title := anObject! !

TestCase subclass: #ITImageDBTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITImageDBTest methodsFor: 'as yet unclassified' stamp: 'afk 11/12/2007 16:27'!
testAddIssue

	| newIssue db returningIssue |
	newIssue := ITIssue new.
	db := ITImageDB connect.
	returningIssue := db addIssue: newIssue.
	
	self assert: ( returningIssue isKindOf: ITIssue ) description: 'Returning Object is not kind of ITIssue'.
	self assert: ( returningIssue id notNil ) description: 'Returning ID is nil'.! !

TestCase subclass: #ITIssueManagerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssueManagerTest methodsFor: 'as yet unclassified' stamp: 'afk 11/12/2007 16:33'!
testAddIssue
	
	| IssueManager returningIssue |
	IssueManager := ITIssueManager new.
	
	returningIssue := IssueManager addIssueWithTitle: 'A Test Issue'.
	self assert: (returningIssue isKindOf: ITIssue) description: 'addIssue is not returning an Issue object'.
	! !

TestCase subclass: #ITIssueTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!
